package yuehaoxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type Volume struct {
	Table
	reception reception
	models    string `data:"volume"`
	create    string `name:"create reception_uid*:select volume_total*=100 begin_time:select@date end_time:select@date" role:"leader"`
}

func (s Volume) Create(m *ice.Message, arg ...string) {
	arg = kit.TransArgKeys(arg, model.VOLUME_TOTAL, model.TOTAL)
	arg = kit.ArgDef(arg, model.BEGIN_TIME, m.Time(), model.END_TIME, m.Time("24h"))
	s.Insert(m.Options(arg), kit.Simple(arg, m.OptionSimple(model.QUEUE_UID))...)
	s.RecordEvent(m, "✅ "+m.Trans("create volume", "创建服务计划")+" "+s.joinKV(m, model.VOLUME_TOTAL, model.BEGIN_TIME, model.END_TIME))
}
func (s Volume) List(m *ice.Message, arg ...string) *ice.Message {
	if len(arg) == 0 {
		if m.Option(model.RECEPTION_UID) != "" {
			s.Fields(m, model.UID, model.BEGIN_TIME, model.END_TIME, model.TOTAL, model.COUNT)
			s.Select(m, m.OptionSimple(model.QUEUE_UID, model.RECEPTION_UID)...)
		}
		return m
	} else if len(arg) == 1 {
		s.Tables(m, s.reception).FieldsWithCreatedAT(m, s,
			model.RECEPTION_NAME, model.BEGIN_TIME, model.END_TIME,
			model.TOTAL, model.COUNT, model.EXPIRE, model.FINISH, model.USER_UID,
		)
		s.Select(m, s.Key(s, model.QUEUE_UID), arg[0])
		s.SelectJoinUser(m)
		m.Display("")
	}
	return m
}

func init() { ice.TeamCtxCmd(Volume{}) }

func (s Volume) joinKV(m *ice.Message, arg ...string) string {
	list := []string{}
	kit.For(arg, func(k string) { list = append(list, k, m.Option(k)) })
	return kit.JoinKV(": ", "\n", list...)
}
